#lang errortrace racket

;(require rackunit)

(struct point (x y z) #:transparent)

(define pt (point 1 2 3))

;; pt
;;
;; (displayln (format "x=~a y=~a z=~a"
;;   (point-x pt) (point-y pt) (point-z pt)))
;;
;; (displayln (format "(point? 10) = ~a" (point? 10)))
;; (displayln (format "(point? pt) = ~a" (point? pt)))

(struct name (first middle last))
(define n (name "John" "M" "Smith"))

;(point-x n)

;; (check-equal? "John" (name-first n))
;; (check-true (name? n))   ; We have predicates that test the type of the value
;; (check-false (point? n)) ; A name is not a point
;; (check-false (list? n))  ; A name is not a list


(struct r:number (value) #:transparent)

; (r:number 3)

(struct r:void () #:transparent)

; (r:void)

(struct r:variable (name) #:transparent)

(struct r:lambda (params body) #:transparent)

; '(lambda (x) 3)
; (r:lambda (list (r:variable 'x)) (list (r:number 3)))


(struct r:apply (func args) #:transparent)

; input = (list 1 2 3)
(define (copy l)
  (match l
    [(list)
     ; input = '()
     (list)
    ]
    [(list h l ...)
      ; h = 1
      ; l = (list 2 3)
      (define result (copy l))
      ; result = (list 2 3)
      ; expected output = (list 1 2 3)
      (cons h result)
    ]
  )
)
; (copy (list 1 2 3))

; input = (list 1.1 2.6 3.0)
; output = (list 1 2 3)
(define (list-exact-floor l)
  (match l
    [(list)
     ; input = '()
     ; output = '()
     (list)
    ]
    [(list h l ...)
      ; h = 1.1
      ; l = (list 2.6 3.0)
      (define result (list-exact-floor l))
      ; result = (list 2 3)
      ; expected output = (list 1 2 3)
      (cons (exact-floor h) result)
    ]
  )
)
;(list-exact-floor (list 1.1 2.6 3.0))



(define (map func l)
  (match l
    [(list)
     ; input = '()
     ; output = '()
     (list)
    ]
    [(list h l ...)
      ; h = 1.1
      ; l = (list 2.6 3.0)
      (define result (map func l))
      ; result = (list 2 3)
      ; expected output = (list 1 2 3)
      (cons (func h) result)
    ]
  )
)

; (list-exact-floor (list 1.1 2.6 3.0))

(define (inc x)
 ;(displayln x)
 (+ x 1))

(map
  (lambda (x)
    (exact-floor (+ x 1))
  )
  (list 1.1 2.6 3.0))






